#!/system/bin/sh

#HUAWEI EC6108V9U Dual-Networks Patch v3.5
#Developed by the mick221
#2016-04-08

single_line=`busybox sed -e '/^enable_single_line=/!d;s/.*=//' /system/etc/auto-config.ini | busybox awk '{print $1}'`
double_line=`busybox sed -e '/^enable_double_line=/!d;s/.*=//' /system/etc/auto-config.ini | busybox awk '{print $1}'`

single_ip=`busybox sed -e '/^single_ip=/!d;s/.*=//' /system/etc/auto-config.ini | busybox awk '{print $1}'`
single_mask=`busybox sed -e '/^single_mask=/!d;s/.*=//' /system/etc/auto-config.ini | busybox awk '{print $1}'`
single_gateway=`busybox sed -e '/^single_gateway=/!d;s/.*=//' /system/etc/auto-config.ini | busybox awk '{print $1}'`
single_dns=`busybox sed -e '/^single_dns=/!d;s/.*=//' /system/etc/auto-config.ini | busybox awk '{print $1}'`

iptvapp_list=`cat /system/etc/auto-config.ini | grep name= | busybox awk 'BEGIN{ORS="|"} {print $1}'`
iptvapp_list=`echo ${iptvapp_list%"|"*}`

last_route="unknow"

time_count=0

while [ 1 ]
do
	time_count=`expr $time_count + 0.5`
	
	eth_link=$(getprop net.linkdetailed.eth)
	eth_dhcp=$(getprop init.svc.dhcpcd_eth0)
	eth_current_pid=$(getprop dhcp.eth0.pid)
	
	ppp_status=$(getprop net.ppp.status)
	
	wlan_link=$(getprop net.linkdetailed.wlan)
	wlan_dhcp=$(getprop init.svc.dhcpcd_wlan0)
	wlan_current_pid=$(getprop dhcp.wlan0.pid)
	
	itv_if="${eth_link:2:4}"
	
	if [ "$single_line" = "1" -a "${eth_link:0:1}" = "1" -a "${wlan_dhcp:0:1}" != "r" ] ; then
	
		if [ "$itv_if" = "eth0" -a "${eth_dhcp:0:1}" = "r" ] ; then
			itv_ip=$(getprop dhcp.eth0.ipaddress)
			itv_gw=$(getprop dhcp.eth0.gateway)
			itv_dns=$(getprop dhcp.eth0.dns1)
		fi
			
		if  [ "$itv_if" = "ppp0" -a "$ppp_status" = "1" ] ; then
			itv_ip=$(getprop persist.ppp.last_ip)
			itv_gw=$(getprop pppoe.ppp0.gateway)
			itv_dns=$(getprop pppoe.ppp0.dns1)
		fi
		
		web_ip="$single_ip/$single_mask"
		web_gw="$single_gateway"
		web_dns="$single_dns"
		
		check_ip=$( ip ro ls | grep "src $single_ip" | busybox wc -l )
		if [ $check_ip -lt 1 ] ; then
			ip address add $web_ip dev eth0
		fi
			
		web_if="eth0"
		
		check_app=$( dumpsys window w | grep -E $iptvapp_list | grep / | busybox wc -l )
	
		if [ $check_app -ge 1 ] ; then
	
			if [ "$last_route" != "eth_itv" -o "$eth_current_pid" != "$eth_last_pid" ] ; then		
				ip route del
				ip route add default via $itv_gw dev $itv_if
				ndc resolver flushdefaultif
				ndc resolver setifdns $itv_if "" $itv_dns $web_dns
				ndc resolver setdefaultif $itv_if
				last_route="eth_itv"
				eth_last_pid=$(getprop dhcp.eth0.pid)
			fi
		
		fi
		
		if [ $check_app -lt 1 ] ; then
		
			if [ "$last_route" != "eth_web" -o "$eth_current_pid" != "$eth_last_pid" ] ; then
				ip route del
				ip route add default via $web_gw dev $web_if
				ndc resolver flushdefaultif
				ndc resolver setifdns $web_if "" $web_dns $itv_dns
				ndc resolver setdefaultif $web_if
				last_route="eth_web"
				eth_last_pid=$(getprop dhcp.eth0.pid)
			fi
			
		fi	
		
		check_if=`ip ro ls | grep "default via" | busybox awk '{print $5}'`
		check_gw=`ip ro ls | grep "default via" | busybox awk '{print $3}'`
		if [ $check_app -lt 1 -a "$check_if" != "$web_if" ] || [ $check_app -lt 1 -a "$check_gw" != "$web_gw" ] ; then
			ip route del
			ip route add default via $web_gw dev $web_if
			ndc resolver flushdefaultif
			ndc resolver setifdns $web_if "" $web_dns $itv_dns
			ndc resolver setdefaultif $web_if
			last_route="eth_web"
		fi
			
	fi	
	
	if [ "$double_line" = "1" -a "${wlan_link:0:1}" = "1" -a "${wlan_dhcp:0:1}" = "r" -a "${eth_link:0:1}" = "1" ] ; then
			
		if [ "$itv_if" = "eth0" ] ; then
			itv_ip=$(getprop dhcp.eth0.ipaddress)
			itv_gw=$(getprop dhcp.eth0.gateway)
			itv_dns=$(getprop dhcp.eth0.dns1)
		fi
	
		if  [ "$itv_if" = "ppp0" ] ; then
			itv_ip=$(getprop persist.ppp.last_ip)
			itv_gw=$(getprop pppoe.ppp0.gateway)
			itv_dns=$(getprop pppoe.ppp0.dns1) 
		fi
	
		web_ip=$(getprop dhcp.wlan0.ipaddress)
		web_gw=$(getprop dhcp.wlan0.gateway)
		web_dns=$(getprop dhcp.wlan0.dns1)
	
		web_if="wlan0"
	
		check_app=$( dumpsys window w | grep -E $iptvapp_list | grep / | busybox wc -l )
	
		if [ $check_app -ge 1 ] ; then

			if [ "$last_route" != "eth_itv" -o "$wlan_current_pid" != "$wlan_last_pid" ] ; then		
				ip route del
				ip route add default via $itv_gw dev $itv_if
				ndc resolver flushdefaultif
				ndc resolver setifdns $itv_if "" $itv_dns $web_dns
				ndc resolver setdefaultif $itv_if
				last_route="eth_itv"
				wlan_last_pid=$(getprop dhcp.wlan0.pid)
			fi
		
		fi
		
		if [ $check_app -lt 1 ] ; then
	
			if [ "$last_route" != "wlan_web" -o "$wlan_current_pid" != "$wlan_last_pid" ] ; then
				ip route del
				ip route add default via $web_gw dev $web_if
				ndc resolver flushdefaultif
				ndc resolver setifdns $web_if "" $web_dns $itv_dns
				ndc resolver setdefaultif $web_if
				last_route="wlan_web"
				wlan_last_pid=$(getprop dhcp.wlan0.pid)
			fi
		
		fi
		
		check_if=`ip ro ls | grep "default via" | busybox awk '{print $5}'`
		check_gw=`ip ro ls | grep "default via" | busybox awk '{print $3}'`
		if [ $check_app -lt 1 -a "$check_if" != "$web_if" ] || [ $check_app -lt 1 -a "$check_gw" != "$web_gw" ] ; then
			ip route del
			ip route add default via $web_gw dev $web_if
			ndc resolver flushdefaultif
			ndc resolver setifdns $web_if "" $web_dns $itv_dns
			ndc resolver setdefaultif $web_if
			last_route="wlan_web"
			wlan_last_pid=$(getprop dhcp.wlan0.pid)
		fi
		
		check_if=`ip ro ls | grep "default via" | busybox awk '{print $5}'`
		if [ $check_app -lt 1 -a "$web_if" = "wlan0" -a "$check_if" != "wlan0" ] ; then
			ip link set wlan0 down
			ip link set wlan0 up
		fi	
			
	fi
		
	proccess_config=$( busybox ps | grep /system/etc/auto-config.sh | grep -v "grep" | busybox wc -l )
    if [ $proccess_config -lt 1 ] ; then
        /system/etc/auto-config.sh &
    fi
	
	sleep 0.5
	
	if [ $time_count -gt 2221 ] ; then
		exit 0
	fi
	
done
